<?php

define('IN_PHPBB', true);
$phpbb_root_path = './';
include($phpbb_root_path . 'extension.inc');
include($phpbb_root_path . 'common.'.$phpEx);

// Start session management
$userdata = session_pagestart($user_ip, PAGE_INDEX);
init_userprefs($userdata);

// Output page header
$page_title = 'Bedankomat';
include($phpbb_root_path . 'includes/page_header.'.$phpEx);

// Initiate template
$template->set_filenames(array(
	'body' => 'bedankomat_list_body.tpl')
);

// Get start value for list
$start = ( isset($HTTP_POST_VARS['start']) ) ? $HTTP_POST_VARS['start'] : $HTTP_GET_VARS['start'];
$start = ( $start ) ? $start : 0;

// Posts per page
$per_page = ( $userdata['user_posts_per_page'] == '' ) ? $board_config['posts_per_page'] : $userdata['user_posts_per_page'];

$topic_id = $topic_title = $topic_info = $topic_status = $forum_name = $forum_id = array();

// Get datarows
$sql = "SELECT t.topic_id, t.topic_title, t.topic_status, f.forum_name, f.forum_id
	FROM " . TOPICS_TABLE . " t, " . FORUMS_TABLE . " f, " . BEDANKOMAT_TABLE . " b
	WHERE b.topic_id = t.topic_id
	AND f.forum_id = t.forum_id
	GROUP BY t.topic_id, t.topic_title, t.topic_status, f.forum_name, f.forum_id
	ORDER BY f.forum_name, t.topic_title
	LIMIT $start, $per_page";
if ( !($result = $db->sql_query($sql)) )
{
	message_die(GENERAL_ERROR, "Could not obtain topic information", '', __LINE__, __FILE__, $sql);
}

while ( $row = $db->sql_fetchrow($result) )
{
        $auth_mod = auth(AUTH_ALL, $row['forum_id'], $userdata);
	if ( $auth_mod['auth_view'] || $auth_mod['auth_read'] )
	{
		$topic_id[] = $row['topic_id'];
		$topic_title[] = $row['topic_title'];
		$topic_status[] = $row['topic_status'];
		$forum_name[] = $row['forum_name'];
		$forum_id[] = $row['forum_id'];
	}
}
$db->sql_freeresult($result);

// Get all rows
$sql = "SELECT t.*
	FROM " . TOPICS_TABLE . " t, " . FORUMS_TABLE . " f, " . BEDANKOMAT_TABLE . " b
	WHERE b.topic_id = t.topic_id
	AND f.forum_id = t.forum_id
	GROUP BY t.topic_id, t.topic_title, t.topic_status, f.forum_name, f.forum_id
	ORDER BY f.forum_name, t.topic_title";
if ( !($result = $db->sql_query($sql)) )
{
	message_die(GENERAL_ERROR, "Could not obtain topic information", '', __LINE__, __FILE__, $sql);
}

// Count datarows
$total_topics = 0;
while ( $row = $db->sql_fetchrow($result) )
{
        $auth_mod = auth(AUTH_ALL, $row['forum_id'], $userdata);
	if ( $auth_mod['auth_view'] || $auth_mod['auth_read'] )
	{
		$total_topics++;
	}
}
$db->sql_freeresult($result);

// Pagination
$pagination = generate_pagination("bedankomat_list.$phpEx?b=0", $total_topics, $per_page, $start);

$page = ( ceil( $total_topics / $per_page ) != 0 ) ? sprintf($lang['Page_of'], ( floor( $start / $per_page ) + 1 ), ceil( $total_topics / $per_page )) : '';

// Send table headers
$template->assign_vars(array(
	'L_FORUM_NAME' => $lang['Forum'],
	'L_TOPIC_TITLE' => $lang['Topic'],

	'PAGINATION' => $pagination,
	'PAGE_NUMBER' => $page)

);

// Loop through the datarows
for ( $i = 0; $i < count($topic_id); $i++ )
{
	// Get bedankomat users
	$topic = $topic_id[$i];

	$sql = "SELECT u.username FROM " . BEDANKOMAT_TABLE . " b, " . USERS_TABLE . " u
		WHERE b.user_id = u.user_id
		AND b.topic_id = $topic";
	if ( !($result = $db->sql_query($sql)) )
	{
		message_die(GENERAL_ERROR, 'Could not obtain topic-bedankomat information', '', __LINE__, __FILE__, $sql);
	}

	$thx_users = array();
	$num_thxs = $db->sql_numrows($result);
	$thx_users = $db->sql_fetchrowset($result);

	$l_thx_userlist = '';

	for ($index=0; $index<$num_thxs; $index++)
	{
		$l_thx_userlist .= ($index==0) ? $thx_users[$index]['username'] : ', ' . $thx_users[$index]['username'];
	}

	if ( $num_thxs != 0 )
	{
		// Define row color
		$row_class = ( $row_class == '' ) ? $theme['td_class1'] : $row_class;
		$row_class = ( $row_class == $theme['td_class1'] ) ? $theme['td_class2'] : $theme['td_class1'];

		// Send vars to template
		$template->assign_block_vars('topicrow', array(
			'FORUM_NAME' => $forum_name[$i],
			'TOPIC_TITLE' => $topic_title[$i],
			'ROW_CLASS' => $row_class,
			'BEDANKOMAT_USERS' => $l_thx_userlist,

			'U_VIEW_TOPIC' => append_sid("viewtopic.$phpEx?" . POST_TOPIC_URL . "=".($topic_id[$i])),
			'U_VIEW_FORUM' => append_sid("viewforum.$phpEx?" . POST_FORUM_URL . "=".($forum_id[$i])))
		);
	}

	$db->sql_freeresult($result);
}

$template->pparse('body');

include($phpbb_root_path . 'includes/page_tail.'.$phpEx);

?>